import { Libp2p } from 'libp2p';
import { Pushable } from 'it-pushable';
import { WebRTCStarTuple } from '@libp2p/webrtc-star';
import type { Stream as P2PStream, Connection } from '@libp2p/interface-connection';
import type { PeerInfo } from '@libp2p/interface-peer-info';
import { PeerId } from '@libp2p/interface-peer-id';
import { Multiaddr } from '@multiformats/multiaddr';
export declare const CHAT_PROTOCOL = "/chat/1.0.0";
export declare const DEFAULT_SIGNAL_SERVER_URL = "/ip4/127.0.0.1/tcp/13579/wss/p2p-webrtc-star";
export declare class Peer {
    _node?: Libp2p;
    _wrtcStar: WebRTCStarTuple;
    _relayNodeMultiaddr?: Multiaddr;
    _remotePeerIds: PeerId[];
    _peerStreamMap: Map<string, Pushable<any>>;
    _messageHandlers: Array<(peerId: PeerId, message: any) => void>;
    constructor(nodejs?: boolean);
    get peerId(): PeerId | undefined;
    get node(): Libp2p | undefined;
    init(signalServerURL?: string, relayNodeURL?: string): Promise<void>;
    close(): Promise<void>;
    broadcastMessage(message: any): void;
    subscribeMessage(handler: (peerId: PeerId, message: any) => void): () => void;
    _handleDiscovery(peer: PeerInfo): void;
    _handleConnect(connection: Connection): void;
    _handleDisconnect(connection: Connection): void;
    _connectPeer(peer: PeerInfo): Promise<void>;
    _handleStream(peerId: PeerId, stream: P2PStream): void;
}
