//
// Copyright 2022 Vulcanize, Inc.
//
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { createLibp2p } from 'libp2p';
// For nodejs.
import wrtc from 'wrtc';
import assert from 'assert';
import { pipe } from 'it-pipe';
import * as lp from 'it-length-prefixed';
import map from 'it-map';
import { pushable } from 'it-pushable';
import { fromString as uint8ArrayFromString } from 'uint8arrays/from-string';
import { toString as uint8ArrayToString } from 'uint8arrays/to-string';
import { webRTCStar } from '@libp2p/webrtc-star';
import { noise } from '@chainsafe/libp2p-noise';
import { mplex } from '@libp2p/mplex';
import { multiaddr } from '@multiformats/multiaddr';
import { floodsub } from '@libp2p/floodsub';
import { pubsubPeerDiscovery } from '@libp2p/pubsub-peer-discovery';
import { PUBSUB_DISCOVERY_INTERVAL } from './constants.js';
export var CHAT_PROTOCOL = '/chat/1.0.0';
export var DEFAULT_SIGNAL_SERVER_URL = '/ip4/127.0.0.1/tcp/13579/wss/p2p-webrtc-star';
var Peer = /** @class */ (function () {
    function Peer(nodejs) {
        this._remotePeerIds = [];
        this._peerStreamMap = new Map();
        this._messageHandlers = [];
        // Instantiation in nodejs.
        if (nodejs) {
            this._wrtcStar = webRTCStar({ wrtc: wrtc });
        }
        else {
            this._wrtcStar = webRTCStar();
        }
    }
    Object.defineProperty(Peer.prototype, "peerId", {
        get: function () {
            var _a;
            return (_a = this._node) === null || _a === void 0 ? void 0 : _a.peerId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Peer.prototype, "node", {
        get: function () {
            return this._node;
        },
        enumerable: false,
        configurable: true
    });
    Peer.prototype.init = function (signalServerURL, relayNodeURL) {
        if (signalServerURL === void 0) { signalServerURL = DEFAULT_SIGNAL_SERVER_URL; }
        return __awaiter(this, void 0, void 0, function () {
            var peerDiscovery, _a, relayMultiaddr;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (relayNodeURL) {
                            this._relayNodeMultiaddr = multiaddr(relayNodeURL);
                            peerDiscovery = [
                                pubsubPeerDiscovery({
                                    interval: PUBSUB_DISCOVERY_INTERVAL
                                })
                            ];
                        }
                        else {
                            peerDiscovery = [this._wrtcStar.discovery];
                        }
                        _a = this;
                        return [4 /*yield*/, createLibp2p({
                                addresses: {
                                    // Add the signaling server address, along with our PeerId to our multiaddrs list
                                    // libp2p will automatically attempt to dial to the signaling server so that it can
                                    // receive inbound connections from other peers
                                    listen: [
                                        // Public signal servers
                                        // '/dns4/wrtc-star1.par.dwebops.pub/tcp/443/wss/p2p-webrtc-star',
                                        // '/dns4/wrtc-star2.sjc.dwebops.pub/tcp/443/wss/p2p-webrtc-star'
                                        signalServerURL
                                    ]
                                },
                                transports: [
                                    this._wrtcStar.transport
                                ],
                                connectionEncryption: [noise()],
                                streamMuxers: [mplex()],
                                pubsub: floodsub(),
                                peerDiscovery: peerDiscovery,
                                relay: {
                                    enabled: true,
                                    autoRelay: {
                                        enabled: true,
                                        maxListeners: 2
                                    }
                                },
                                connectionManager: {
                                    maxDialsPerPeer: 3,
                                    autoDial: false
                                }
                            })];
                    case 1:
                        _a._node = _b.sent();
                        console.log('libp2p node created', this._node);
                        if (!this._relayNodeMultiaddr) return [3 /*break*/, 3];
                        relayMultiaddr = this._relayNodeMultiaddr;
                        console.log("Dialling relay node ".concat(relayMultiaddr.getPeerId(), " using multiaddr ").concat(relayMultiaddr.toString()));
                        return [4 /*yield*/, this._node.dial(relayMultiaddr)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        // Listen for change in stored multiaddrs
                        this._node.peerStore.addEventListener('change:multiaddrs', function (evt) {
                            assert(_this._node);
                            var _a = evt.detail, peerId = _a.peerId, multiaddrs = _a.multiaddrs;
                            // Log updated self multiaddrs
                            if (peerId.equals(_this._node.peerId)) {
                                console.log('Updated self multiaddrs', _this._node.getMultiaddrs().map(function (addr) { return addr.toString(); }));
                            }
                            else {
                                console.log('Updated peer node multiaddrs', multiaddrs.map(function (addr) { return addr.toString(); }));
                            }
                        });
                        // Listen for peers discovery
                        this._node.addEventListener('peer:discovery', function (evt) {
                            // console.log('event peer:discovery', evt);
                            _this._handleDiscovery(evt.detail);
                        });
                        // Listen for peers connection
                        this._node.connectionManager.addEventListener('peer:connect', function (evt) {
                            console.log('event peer:connect', evt);
                            _this._handleConnect(evt.detail);
                        });
                        // Listen for peers disconnecting
                        this._node.connectionManager.addEventListener('peer:disconnect', function (evt) {
                            console.log('event peer:disconnect', evt);
                            _this._handleDisconnect(evt.detail);
                        });
                        // Handle messages for the protocol
                        return [4 /*yield*/, this._node.handle(CHAT_PROTOCOL, function (_a) {
                                var stream = _a.stream, connection = _a.connection;
                                return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_b) {
                                        this._handleStream(connection.remotePeer, stream);
                                        return [2 /*return*/];
                                    });
                                });
                            })];
                    case 4:
                        // Handle messages for the protocol
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var hangUpPromises;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        this._node.removeEventListener('peer:discovery');
                        this._node.connectionManager.removeEventListener('peer:connect');
                        this._node.connectionManager.removeEventListener('peer:disconnect');
                        return [4 /*yield*/, this._node.unhandle(CHAT_PROTOCOL)];
                    case 1:
                        _a.sent();
                        hangUpPromises = this._remotePeerIds.map(function (peerId) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                            return [2 /*return*/, (_a = this._node) === null || _a === void 0 ? void 0 : _a.hangUp(peerId)];
                        }); }); });
                        return [4 /*yield*/, Promise.all(hangUpPromises)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.broadcastMessage = function (message) {
        var e_1, _a;
        try {
            for (var _b = __values(this._peerStreamMap), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), stream = _d[1];
                stream.push(message);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    Peer.prototype.subscribeMessage = function (handler) {
        var _this = this;
        this._messageHandlers.push(handler);
        var unsubscribe = function () {
            _this._messageHandlers = _this._messageHandlers
                .filter(function (registeredHandler) { return registeredHandler !== handler; });
        };
        return unsubscribe;
    };
    Peer.prototype._handleDiscovery = function (peer) {
        // Check connected peers as they are discovered repeatedly.
        if (!this._remotePeerIds.some(function (remotePeerId) { return remotePeerId.toString() === peer.id.toString(); })) {
            console.log('Discovered peer multiaddrs', peer.multiaddrs.map(function (addr) { return addr.toString(); }));
            this._connectPeer(peer);
        }
    };
    Peer.prototype._handleConnect = function (connection) {
        var remotePeerId = connection.remotePeer;
        this._remotePeerIds.push(remotePeerId);
        // Log connected peer
        console.log("Connected to ".concat(remotePeerId.toString(), " using multiaddr ").concat(connection.remoteAddr.toString()));
    };
    Peer.prototype._handleDisconnect = function (connection) {
        var disconnectedPeerId = connection.remotePeer;
        this._remotePeerIds = this._remotePeerIds.filter(function (remotePeerId) { return remotePeerId.toString() !== disconnectedPeerId.toString(); });
        // Log disconnected peer
        console.log("Disconnected from ".concat(disconnectedPeerId.toString(), " using multiaddr ").concat(connection.remoteAddr.toString()));
    };
    Peer.prototype._connectPeer = function (peer) {
        return __awaiter(this, void 0, void 0, function () {
            var relayMultiaddr_1, relayNodePeerId, _a, _b, peerMultiaddr, stream, err_1, e_2_1;
            var e_2, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        assert(this._node);
                        if (!this._relayNodeMultiaddr) return [3 /*break*/, 2];
                        relayMultiaddr_1 = this._relayNodeMultiaddr;
                        relayNodePeerId = relayMultiaddr_1.getPeerId();
                        if (!(relayNodePeerId && relayNodePeerId === peer.id.toString())) return [3 /*break*/, 2];
                        console.log("Dialling relay peer ".concat(peer.id.toString(), " using multiaddr ").concat(relayMultiaddr_1.toString()));
                        return [4 /*yield*/, this._node.dial(relayMultiaddr_1).catch(function (err) {
                                console.log("Could not dial relay ".concat(relayMultiaddr_1.toString()), err);
                            })];
                    case 1:
                        _d.sent();
                        return [2 /*return*/];
                    case 2:
                        _d.trys.push([2, 9, 10, 11]);
                        _a = __values(peer.multiaddrs), _b = _a.next();
                        _d.label = 3;
                    case 3:
                        if (!!_b.done) return [3 /*break*/, 8];
                        peerMultiaddr = _b.value;
                        _d.label = 4;
                    case 4:
                        _d.trys.push([4, 6, , 7]);
                        console.log("Dialling peer ".concat(peer.id.toString(), " using multiaddr ").concat(peerMultiaddr.toString()));
                        return [4 /*yield*/, this._node.dialProtocol(peerMultiaddr, CHAT_PROTOCOL)];
                    case 5:
                        stream = _d.sent();
                        this._handleStream(peer.id, stream);
                        return [3 /*break*/, 8];
                    case 6:
                        err_1 = _d.sent();
                        console.log("Could not dial ".concat(peerMultiaddr.toString()), err_1);
                        return [3 /*break*/, 7];
                    case 7:
                        _b = _a.next();
                        return [3 /*break*/, 3];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleStream = function (peerId, stream) {
        var _this = this;
        // console.log('Stream after connection', stream);
        var messageStream = pushable({ objectMode: true });
        // Send message to pipe from stdin
        pipe(
        // Read from stream (the source)
        messageStream, 
        // Turn objects into buffers
        function (source) { return map(source, function (value) {
            return uint8ArrayFromString(JSON.stringify(value));
        }); }, 
        // Encode with length prefix (so receiving side knows how much data is coming)
        lp.encode(), 
        // Write to the stream (the sink)
        stream.sink);
        // Handle message from stream
        pipe(
        // Read from the stream (the source)
        stream.source, 
        // Decode length-prefixed data
        lp.decode(), 
        // Turn buffers into objects
        function (source) { return map(source, function (buf) {
            return JSON.parse(uint8ArrayToString(buf.subarray()));
        }); }, 
        // Sink function
        function (source) { var _a, source_1, source_1_1; return __awaiter(_this, void 0, void 0, function () {
            var _loop_1, this_1, e_3_1;
            var _b, e_3, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 5, 6, 11]);
                        _loop_1 = function () {
                            _d = source_1_1.value;
                            _a = false;
                            try {
                                var msg = _d;
                                this_1._messageHandlers.forEach(function (messageHandler) { return messageHandler(peerId, msg); });
                            }
                            finally {
                                _a = true;
                            }
                        };
                        this_1 = this;
                        _a = true, source_1 = __asyncValues(source);
                        _e.label = 1;
                    case 1: return [4 /*yield*/, source_1.next()];
                    case 2:
                        if (!(source_1_1 = _e.sent(), _b = source_1_1.done, !_b)) return [3 /*break*/, 4];
                        _loop_1();
                        _e.label = 3;
                    case 3: return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 11];
                    case 5:
                        e_3_1 = _e.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 11];
                    case 6:
                        _e.trys.push([6, , 9, 10]);
                        if (!(!_a && !_b && (_c = source_1.return))) return [3 /*break*/, 8];
                        return [4 /*yield*/, _c.call(source_1)];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        if (e_3) throw e_3.error;
                        return [7 /*endfinally*/];
                    case 10: return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        }); });
        // TODO: Check if stream already exists for peer id
        this._peerStreamMap.set(peerId.toString(), messageStream);
    };
    return Peer;
}());
export { Peer };
//# sourceMappingURL=index.js.map